VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Files"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##MODULE_IS_NEW
'##CD Provides ftp support for your applications. This class will be great for allowing auto downloads of patches from your ftp server.
Attribute VB_HelpID=2345
Attribute VB_Description="Provides ftp support for your applications. This class will be great for allowing auto downloads of patches from your ftp server."
Option Explicit

'File Transfer types
Public Enum FileTransferType
'##EN File transfer types.
    ftAscii = FTP_TRANSFER_TYPE_ASCII
    '## ftAscii ASCII transfer type.
    ftBinary = FTP_TRANSFER_TYPE_BINARY
    '## ftBinary Binary transfer type.
End Enum

'Standard FTP properties for this class
Private msHostAddress As String
Private msUser As String
Private msPassword As String
Private msDirectory As String
Private mvarFiles As Files
Private mvarLocalIPAddress As String
Private mvarLocalHostName As String

'##BLOCK_IS_NEW
Public Function GetLocalIPAddress() As String
Attribute GetLocalIPAddress.VB_HelpID = 2346
Attribute GetLocalIPAddress.VB_Description = "Returns the Local IP Address."
'##BD Returns the Local IP Address.

'##RD Local IP address.
    Dim sHostName    As String * 256
    Dim lpHost    As Long
    Dim Host      As HOSTENT
    Dim dwIPAddr  As Long
    Dim tmpIPAddr() As Byte
    Dim i         As Integer
    Dim sIPAddr  As String
    
    If Not SocketsInitialize() Then
        GetLocalIPAddress = ""
        Exit Function
    End If
    
    'gethostname returns the name of the local host into the buffer specified by the name parameter. The host
    'name is returned as a null-terminated string. The form of the host name is dependent on the Windows
    'Sockets provider - it can be a simple host name, or it can be a fully qualified domain name. However, it
    'is guaranteed that the name returned will be successfully parsed by gethostbyname and WSAAsyncGetHostByName.
    
    'In actual application, if no local host name has been configured, gethostname must succeed and return a token
    'host name that gethostbyname or WSAAsyncGetHostByName can resolve.
    If gethostname(sHostName, 256) = SOCKET_ERROR Then
        GetLocalIPAddress = ""
        MsgBox "Windows Sockets error " & Str$(WSAGetLastError()) & _
            " has occurred. Unable to successfully get Host Name."
        Call SocketsCleanup
        Exit Function
    End If
    
    'gethostbyname returns a pointer to a HOSTENT structure - a structure allocated by Windows Sockets. The HOSTENT
    'structure contains the results of a successful search for the host specified in the name parameter.
    
    'The application must never attempt to modify this structure or to free any of its components. Furthermore,
    'only one copy of this structure is allocated per thread, so the application should copy any information it needs
    'before issuing any other Windows Sockets function calls.
    
    'gethostbyname function cannot resolve IP address strings passed to it. Such a request is treated exactly as if an
    'unknown host name were passed. Use inet_addr to convert an IP address string the string to an actual IP address,
    'then use another function, gethostbyaddr, to obtain the contents of the HOSTENT structure.
    sHostName = Trim$(sHostName)
    lpHost = gethostbyname(sHostName)
    
    If lpHost = 0 Then
        GetLocalIPAddress = ""
        MsgBox "Windows Sockets are not responding. " & _
              "Unable to successfully get Host Name."
        Call SocketsCleanup
        Exit Function
    End If
    
    'to extract the returned IP address, we have to copy the HOST structure and its members
    CopyMemory Host, lpHost, Len(Host)
    CopyMemory dwIPAddr, Host.hAddrList, 4
   
    'create an array to hold the result
    ReDim tmpIPAddr(1 To Host.hLen)
    CopyMemory tmpIPAddr(1), dwIPAddr, Host.hLen
   
    'and with the array, build the actual address, appending a period between members
    For i = 1 To Host.hLen
        sIPAddr = sIPAddr & tmpIPAddr(i) & "."
    Next
  
    'the routine adds a period to the end of the string, so remove it here
    GetLocalIPAddress = Mid$(sIPAddr, 1, Len(sIPAddr) - 1)
   
    Call SocketsCleanup
End Function

'##BLOCK_IS_NEW
Public Function GetHostNameFromIP(ByVal sAddress As String) As String
Attribute GetHostNameFromIP.VB_HelpID = 2347
Attribute GetHostNameFromIP.VB_Description = "Returns a domain name from a given IP."
'##BD Returns a domain name from a given IP.

'##PD sAddress IP address to get the domain name from.
'##RD Domain name.
    Dim ptrHosent As Long
    Dim hAddress As Long
    Dim nbytes As Long
   
    If SocketsInitialize() Then
        'convert string address to long
        hAddress = inet_addr(sAddress)
      
        If hAddress <> SOCKET_ERROR Then
            'obtain a pointer to the HOSTENT structure 'that contains the name and address
            'corresponding to the given network address.
            ptrHosent = gethostbyaddr(hAddress, 4, AF_INET)
   
            If ptrHosent <> 0 Then
                'convert address and get resolved hostname
                Call CopyMemory(ptrHosent, ByVal ptrHosent, 4)
                nbytes = lstrlen(ByVal ptrHosent)
         
                If nbytes > 0 Then
                    sAddress = Space$(nbytes)
                    Call CopyMemory(ByVal sAddress, ByVal ptrHosent, nbytes)
                    GetHostNameFromIP = sAddress
                End If
            Else
                'MsgBox "Call to gethostbyaddr failed."
            End If 'If ptrHosent
            Call SocketsCleanup
        Else
            'MsgBox "String passed is an invalid IP."
        End If 'If hAddress
   
    Else
        'MsgBox "Sockets failed to initialize."
    End If  'If SocketsInitialize
End Function
'##BLOCK_IS_NEW
Public Property Get Files() As Files
Attribute Files.VB_HelpID = 2348
Attribute Files.VB_Description = "Returns the files collection."
'##BD Returns the files collection.
    Set Files = mvarFiles
End Property



Private Sub Class_Initialize()
    'Create Internet session handle
    mlINetHandle = InternetOpen(SESSION, INTERNET_OPEN_TYPE_DIRECT, vbNullString, vbNullString, 0)
    
    If mlINetHandle = 0 Then
        mlConnection = 0
        Call MEngine.FireErrorEvent(errFatal, ERRFATALERROR, "FTP | Class_Initialise")
    End If
    
    mlConnection = 0
    Set mvarFiles = New Files
End Sub


Private Sub Class_Terminate()
    On Error Resume Next
    
    Call Disconnect
    
    'Kill off any connection
    If mlConnection <> 0 Then Call InternetCloseHandle(mlConnection)

    'Kill off API Handle
    If mlINetHandle <> 0 Then Call InternetCloseHandle(mlINetHandle)
    
    mlConnection = 0
    mlINetHandle = 0
    Set mvarFiles = Nothing
End Sub

Public Property Let Host(ByVal sHostName As String)
Attribute Host.VB_HelpID = 2349
Attribute Host.VB_Description = "Returns/sets the ftp server name to connect to.  "
    'Set the Host Name - only if not connected
    If mlConnection <> 0 Then Call MEngine.FireErrorEvent(errInvalidProperty, ERRALREADYCONNECTED, "FTP | Host_Let")
    msHostAddress = sHostName
End Property

'##BLOCK_IS_NEW
Public Function GetIPFromHostName(ByVal sHostName As String) As String
Attribute GetIPFromHostName.VB_HelpID = 2350
Attribute GetIPFromHostName.VB_Description = "Returns a IP address from a domain name."
'##BD Returns a IP address from a domain name.

'##PD sHostName Domain name to return a IP address from.
'##RD Returns a IP address.
    'converts a host name to an IP address.
    Dim nbytes As Long
    Dim ptrHosent As Long
    Dim ptrName As Long
    Dim ptrAddress As Long
    Dim ptrIPAddress As Long
    Dim sAddress As String
   
    sAddress = Space$(4)

    ptrHosent = gethostbyname(sHostName & vbNullChar)

    If ptrHosent <> 0 Then

        'assign pointer addresses and offset
     
        'The Address is offset 12 bytes from the start of the HOSENT structure. Note: Here we are retrieving
        'only the first address returned. To return more than one, define sAddress as a string array and loop through
        'the 4-byte ptrIPAddress members returned. The last item is a terminating null. All addresses are returned
        'in network byte order.
        ptrAddress = ptrHosent + 12
      
        'get the IP address
        Call CopyMemory(ptrAddress, ByVal ptrAddress, 4)
        Call CopyMemory(ptrIPAddress, ByVal ptrAddress, 4)
        Call CopyMemory(ByVal sAddress, ByVal ptrIPAddress, 4)

        GetIPFromHostName = IPToText(sAddress)
    End If
End Function
'##BLOCK_IS_NEW
Public Property Get Host() As String
'##BD Returns/sets the ftp server name to connect to.
    Host = msHostAddress
End Property

Public Property Let User(ByVal sUserName As String)
Attribute User.VB_HelpID = 2351
Attribute User.VB_Description = "Login user name.  "
    'Set the user - only if not connected
    If mlConnection <> 0 Then Call MEngine.FireErrorEvent(errInvalidProperty, ERRALREADYCONNECTED, "FTP | User_Let")
    msUser = sUserName
End Property

'##BLOCK_IS_NEW
Public Property Get User() As String
'##BD Login user name.
    User = msUser
End Property

Public Property Let Password(ByVal sPassword As String)
Attribute Password.VB_HelpID = 2352
Attribute Password.VB_Description = "Returns/sets the login password.  "
    'Set the password - only if not connected
    If mlConnection <> 0 Then Call MEngine.FireErrorEvent(errInvalidProperty, ERRALREADYCONNECTED, "FTP | Password_Let")
    msPassword = sPassword
End Property

'##BLOCK_IS_NEW
Public Property Get Password() As String
'##BD Returns/sets the login password.
    Password = msPassword
End Property

'##BLOCK_IS_NEW
Public Property Get Directory() As String
Attribute Directory.VB_HelpID = 2353
Attribute Directory.VB_Description = "Returns/sets the directory.  "
'##BD Returns/sets the directory.
    Directory = msDirectory
End Property

'##BLOCK_IS_NEW
Public Property Let Directory(ByVal sDirectory As String)
    'Set the directory - only if connected
    Dim sError As String
    On Error GoTo Handler

    If Not (mlConnection = 0) Then
        Call RemoteChDir(sDirectory)
        msDirectory = sDirectory
        Call MEngine.FireEvent(10, , , , , , , msDirectory)
    End If
    Exit Property

Handler:
    Call MEngine.FireErrorEvent(errNoDirChange, Err.Description, "FTP | Directory[Let]")
End Property

'##BLOCK_IS_NEW
Public Property Get Connected() As Boolean
Attribute Connected.VB_HelpID = 2354
Attribute Connected.VB_Description = "Returns if we are connected to an FTP Server."
'##BD Returns if we are connected to an FTP Server.
    Connected = (mlConnection <> 0)
End Property

'##BLOCK_IS_NEW
Public Function Connect(Optional Host As String, Optional User As String, Optional Password As String) As Boolean
Attribute Connect.VB_HelpID = 2355
Attribute Connect.VB_Description = "Connect to the FTP server"
'##BD Connect to the FTP server

'##PD Host FTP server name.
'##PD User Login user name.
'##PD Password Login password.
    Dim sError As String
    On Error GoTo Handler
    
    'If we already have a connection then raise an error
    If mlConnection <> 0 Then
        Call MEngine.FireErrorEvent(errInvalidProperty, "You are already connected to FTP Server " & msHostAddress, _
                                            "FTP | Connect Function")
        Exit Function
    End If
    
    'Overwrite any existing properties if they were supplied in the arguments to this method
    If Len(Host) > 0 Then msHostAddress = Host
    If Len(User) > 0 Then msUser = User
    If Len(Password) > 0 Then msPassword = Password

    'Connect !
    If Len(msHostAddress) = 0 Then Call MEngine.FireErrorEvent(errInvalidProperty, "No Host Address Specified!", "FTP | Connect Function")
    
    mlConnection = InternetConnect(mlINetHandle, msHostAddress, INTERNET_INVALID_PORT_NUMBER, _
        msUser, msPassword, INTERNET_SERVICE_FTP, 0, 0)
        
    ' Check for connection errors
    If mlConnection = 0 Then
        sError = Replace(ERRCONNECTERROR, "%s", msHostAddress)
        sError = sError & vbCrLf & GetINETErrorMsg(Err.LastDllError)
        Call MEngine.FireErrorEvent(errCannotConnect, sError, "FTP | Connect Function")
    End If
    
    Connect = True
    Call MEngine.FireEvent(8)
    Exit Function

Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "FTP | Connect Function")
End Function

'##BLOCK_IS_NEW
Public Function Disconnect() As Boolean
Attribute Disconnect.VB_HelpID = 2356
Attribute Disconnect.VB_Description = "Disconnect from the ftp server."
'##BD Disconnect from the ftp server.
    On Error Resume Next
    
    'Disconnect, only if connected !
    If mlConnection <> 0 Then
        Call InternetCloseHandle(mlConnection)
        mlConnection = 0
    Else
        Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | Disconnect")
    End If
    msHostAddress = ""
    msUser = ""
    msPassword = ""
    msDirectory = ""
    Call MEngine.FireEvent(9)
End Function


Friend Sub GetDirectoryList(Optional Directory As String, Optional FilterString As String)
Attribute GetDirectoryList.VB_HelpID = 2357
'Returns a Disconnected record set for the directory and filterstring
    'eg.  "/NTFFiles", "*.ntf"
    Dim oFileColl As Collection, lFind As Long, lLastError As Long, lPtr As Long
    Dim pData As WIN32_FIND_DATA, sFilter As String, lError As Long
    Dim bRet As Boolean, sItemName As String, File As File
    On Error GoTo Handler
    
    'Check if already connected, else raise an error
    If mlConnection = 0 Then Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | GetDirectoryList")

    Call Files.Clear 'Clear any contents
    If Len(Directory) > 0 Then Call RemoteChDir(Directory) 'Change directory if required
    
    pData.cFileName = String$(MAX_PATH, vbNullChar)
    
    If Len(FilterString) > 0 Then sFilter = FilterString Else sFilter = "*.*"
    
    'Get the first file in the directory
    lFind = FtpFindFirstFile(mlConnection, sFilter, pData, 0, 0)
    lLastError = Err.LastDllError

    'If no files, then return an empty recordset.
    If lFind = 0 Then
        If lLastError = ERROR_NO_MORE_FILES Then
        Else
            Call MEngine.FireErrorEvent(lLastError, "Error looking at directory " & Directory & "\" & FilterString, "FTP | GetDirectoryList")
        End If
        Exit Sub
    End If

    'Add the first found file into the recordset
    sItemName = Left$(pData.cFileName, InStr(1, pData.cFileName, vbNullChar, vbBinaryCompare) - 1)
    Set File = Files.Add(sItemName, sItemName, sItemName)
    Call File.SetDataType(pData)
    
    'Get the rest of the files in the list
    Do
        pData.cFileName = String(MAX_PATH, vbNullChar)
        bRet = InternetFindNextFile(lFind, pData)
        If Not (bRet) Then
            lLastError = Err.LastDllError
            If lLastError = ERROR_NO_MORE_FILES Then
                Exit Do
            Else
                Call InternetCloseHandle(lFind)
                Call MEngine.FireErrorEvent(lLastError, "Error looking at directory " & Directory & "\" & FilterString, "FTP | GetDirectoryList")
                Exit Sub
            End If
        Else
            sItemName = Left$(pData.cFileName, InStr(1, pData.cFileName, vbNullChar, vbBinaryCompare) - 1)
            Set File = Files.Add(sItemName, sItemName, sItemName)
            Call File.SetDataType(pData)
        End If
    Loop

    'Close the 'find' handle
    Call InternetCloseHandle(lFind)
    Exit Sub

Handler:
    'Tidy up & raise an error
    If lFind <> 0 Then Call InternetCloseHandle(lFind)
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "FTP | GetDirectoryList")
End Sub

'##BLOCK_IS_NEW
Public Function DownloadFile(ByVal ServerFileAndPath As String, ByVal DestinationFileAndPath As String, Optional TransferType As FileTransferType = ftAscii) As Boolean
Attribute DownloadFile.VB_HelpID = 2358
Attribute DownloadFile.VB_Description = "Downloads a file to the desired location using the specified file transfer type."
'##BD Downloads a file to the desired location using the specified file transfer type.

'##PD ServerFileAndPath File to download.
'##PD DestinationFileAndPath Destination of the file when downloaded.
'##PD TransferType Transfer type.
    Dim bRet As Boolean
    Dim sFileRemote As String
    Dim sDirRemote As String
    Dim sFileLocal As String
    Dim sTemp As String
    Dim lPos As Long
    Dim sError As String
    On Error GoTo Handler

    'If not connected, raise an error
    If mlConnection = 0 Then Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | DownloadFile")
    
    'Get the file
    bRet = FtpGetFile(mlConnection, ServerFileAndPath, DestinationFileAndPath, False, INTERNET_FLAG_RELOAD, TransferType, 0)
    
    If bRet = False Then
        sError = ERRNODOWNLOAD
        sError = Replace(sError, "%s", ServerFileAndPath)
        DownloadFile = False
        Call MEngine.FireErrorEvent(errGetFileError, sError, "FTP | DownloadFile")
        Exit Function
    End If
    
    DownloadFile = True
    Exit Function

Handler:
    DownloadFile = False
    Call MEngine.FireErrorEvent(errGetFileError, Err.Description, "FTP | DownloadFile")
End Function
'##BLOCK_IS_NEW
Public Function UploadFile(ByVal LocalFileAndPath As String, ByVal ServerFileAndPath As String, Optional TransferType As FileTransferType) As Boolean
Attribute UploadFile.VB_HelpID = 2359
Attribute UploadFile.VB_Description = "Places a file onto a ftp server directory."
'##BD Places a file onto a ftp server directory.

'##PD LocalFileAndPath File to transfer.
'##PD ServerFileAndPath Path on the server.
'##PD TransferType Transfer type.
    Dim bRet As Boolean
    Dim sFileRemote As String
    Dim sDirRemote As String
    Dim sFileLocal As String
    Dim sTemp As String
    Dim lPos As Long
    Dim sError As String
    On Error GoTo Handler

    'If not connected, raise an error!
    If mlConnection = 0 Then Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | UploadFile")
    
    bRet = FtpPutFile(mlConnection, LocalFileAndPath, ServerFileAndPath, TransferType, 0)
    If bRet = False Then
        sError = ERRNODOWNLOAD
        sError = Replace(sError, "%s", ServerFileAndPath)
        UploadFile = False
        sError = sError & vbCrLf & GetINETErrorMsg(Err.LastDllError)
        Call MEngine.FireErrorEvent(errCannotRename, sError, "FTP | UploadFile")
    End If
    
    UploadFile = True
    Exit Function

Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "FTP | UploadFile")
End Function

'##BLOCK_IS_NEW
Public Function RenameFile(ByVal ExistingName As String, ByVal NewName As String) As Boolean
Attribute RenameFile.VB_HelpID = 2360
Attribute RenameFile.VB_Description = "Renames a file on a ftp server."
'##BD Renames a file on a ftp server.

'##PD ExistingName Name of the file to rename.
'##PD NewName New name of the file.
    Dim bRet As Boolean
    Dim sError As String
    On Error GoTo Handler

    'If not connected, raise an error
    If mlConnection = 0 Then Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | RenameFile")
   
    bRet = FtpRenameFile(mlConnection, ExistingName, NewName)
    'Raise an error if we couldn't rename the file (most likely that a file with the new name already exists
    If bRet = False Then
        sError = ERRNORENAME
        sError = Replace(sError, "%s", ExistingName)
        RenameFile = False
        sError = sError & vbCrLf & GetINETErrorMsg(Err.LastDllError)
        Call MEngine.FireErrorEvent(errCannotRename, sError, "FTP | RenameFile")
    End If
    
    RenameFile = True
    Exit Function

Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "FTP | RenameFile")
End Function

'##BLOCK_IS_NEW
Public Function DeleteFile(ByVal FileName As String) As Boolean
Attribute DeleteFile.VB_HelpID = 2361
Attribute DeleteFile.VB_Description = "Deletes a file from the ftp server."
'##BD Deletes a file from the ftp server.

'##PD FileName Name of the file to delete.
    Dim bRet As Boolean
    Dim sError As String
    On Error GoTo Handler

    'Check for a connection
    If mlConnection = 0 Then Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | DeleteFile")
   
    bRet = FtpDeleteFile(mlConnection, FileName)
    'Raise an error if the file couldn't be deleted
    If bRet = False Then
        sError = ERRNODELETE
        sError = Replace(sError, "%s", FileName)
        Call MEngine.FireErrorEvent(errCannotDelete, sError, "FTP | DeleteFile")
    End If
    
    DeleteFile = True
    Exit Function

Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "FTP | DeleteFile")
End Function

Private Sub RemoteChDir(ByVal sDir As String)
    On Error GoTo vbErrorHandler
    'Remote Change Directory Command through WININET
    Dim sPathFromRoot As String
    Dim bRet As Boolean
    Dim sError As String

    'Needs standard Unix Convention
    sDir = Replace(sDir, "\", "/")

    'Check for a connection
    If mlConnection = 0 Then
        Call MEngine.FireErrorEvent(errNotConnectedToSite, ERRNOCONNECTION, "FTP | RemoteChDir")
        Exit Sub
    End If
    
    If Len(sDir) = 0 Then
        Exit Sub
    Else
        sPathFromRoot = sDir
        If Len(sPathFromRoot) = 0 Then
            sPathFromRoot = "/"
        End If
        bRet = FtpSetCurrentDirectory(mlConnection, sPathFromRoot)

        'If we couldn't change directory - raise an error
        If bRet = False Then
            sError = ERRCHANGEDIRSTR
            sError = Replace(sError, "%s", sDir)
            Call MEngine.FireErrorEvent(errNoDirChange, sError, "FTP | ChangeDirectory")
        Else
            msDirectory = sPathFromRoot
        End If
    End If
    Exit Sub

vbErrorHandler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "FTP | RemoteChDir")
End Sub

Private Function GetINETErrorMsg(ByVal ErrNum As Long) As String
    Dim lError As Long
    Dim lLen As Long
    Dim sBuffer As String

    'Get Extra Info from the WinInet.DLL
    If ErrNum = ERROR_INTERNET_EXTENDED_ERROR Then

        'Get Message Size and Number
        Call InternetGetLastResponseInfo(lError, vbNullString, lLen)
        sBuffer = String$(lLen + 1, vbNullChar)

        'Get Message
        Call InternetGetLastResponseInfo(lError, sBuffer, lLen)
        GetINETErrorMsg = vbCrLf & sBuffer
    End If
End Function

'##BLOCK_IS_NEW
Public Function GetLocalIPHostName() As String
Attribute GetLocalIPHostName.VB_HelpID = 2362
Attribute GetLocalIPHostName.VB_Description = "Returns the local domain name."
'##BD Returns the local domain name.

'##RD Returns the local domain name.
    Dim sHostName As String * 256
    
    If Not SocketsInitialize() Then
        GetLocalIPHostName = ""
        Exit Function
    End If
    
    If gethostname(sHostName, 256) = SOCKET_ERROR Then
        GetLocalIPHostName = ""
        Call MEngine.FireErrorEvent(WSAGetLastError(), "Unable to successfully get Host Name.", "FTP | GetLocalIPHostName")
        SocketsCleanup
        Exit Function
    End If
    
    GetLocalIPHostName = Left$(sHostName, InStr(sHostName, Chr(0)) - 1)
    SocketsCleanup
End Function

