VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Lobby"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Modems"
'##CD Provides lobby support for your applications allowing you to connect, send messages to the lobby, and allow a lobby to launch your application.
Attribute VB_HelpID=2174
Attribute VB_Description="Provides lobby support for your applications allowing you to connect, send messages to the lobby, and allow a lobby to launch your application."
Option Explicit

Private mvarDPLobbyObject As DirectPlayLobby3
Private mvarRegisteredApplications As RegisteredApps
Private mvarModems As Modems

Public Enum eComPorts
'##EN COM ports.
    COM1 = 1
    '##EM COM1 Com port 1.
    COM2 = 2
    '##EM COM2 Com port 2.
    COM3 = 3
    '##EM COM3 Com port 3.
    COM4 = 4
    '##EM COM4 Com port 4.
End Enum

Public Enum eBaudRates
'##EN Baud rate of the port.
    BaudRate110 = 110
    BaudRate300 = 300
    BaudRate600 = 600
    BaudRate1200 = 1200
    BaudRate2400 = 2400
    BaudRate4800 = 4800
    BaudRate9600 = 9600
    BaudRate14400 = 14400
    BaudRate19200 = 19200
    BaudRate38400 = 38400
    BaudRate56000 = 56000
    BaudRate57600 = 57600
    BaudRate115200 = 115200
    BaudRate128000 = 128000
    BaudRate256000 = 256000
End Enum

Public Enum eStopBits
'##EN Number of stop bits.
    StopBit0 = 0
    '##EM StopBit0 One stop bit
    StopBit1 = 1
    '##EM StopBit1 One and a half stop bits.
    StopBit2 = 2
    '##EM StopBit2 Two stop bits.
End Enum

Public Enum eParity
'##EN Parity.
    [No Parity] = 0
    [Odd Parity] = 1
    [Even Parity] = 2
    [Mark Parity] = 3
End Enum

Public Enum eFlowControl
'##EN Method of flow control.
    [No flow control] = 0
    [Software flow control (xon/xoff)] = 1
    [Hardware flow control with RTS] = 2
    [Hardware flow control with DTR] = 3
    [hardware flow control with RTS and DTR] = 4
End Enum



'##BLOCK_IS_NEW
Public Function GetConnectionSettings() As DirectPlayLobbyConnection
Attribute GetConnectionSettings.VB_HelpID = 2328
Attribute GetConnectionSettings.VB_Description = "retrieves the DirectPlayLobbyConnection object that contains all the information needed to start and connect an application. The data returned is the same data that was passed to the DirectPlayLobby3.RunApplication method by the lobby client, or set by calling the DirectPlayLobby3.SetConnectionSettings method."
'##BD retrieves the DirectPlayLobbyConnection object that contains all the information needed to start and connect an application. The data returned is the same data that was passed to the DirectPlayLobby3.RunApplication method by the lobby client, or set by calling the DirectPlayLobby3.SetConnectionSettings method.
    On Error GoTo Handler
    
    Set GetConnectionSettings = mvarDPLobbyObject.GetConnectionSettings(0)
    Exit Function
    
Handler:
    Set GetConnectionSettings = Nothing
    If Err = DPERR_NOTLOBBIED Then
    
    Else
    
    End If
End Function

'##BLOCK_IS_NEW
Public Property Get Modems() As Modems
Attribute Modems.VB_HelpID = 2329
Attribute Modems.VB_Description = "Returns the Modems collection."
'##BD Returns the Modems collection.
    Set Modems = mvarModems
End Property



'##BLOCK_IS_NEW
Public Function CreateCOMPortAddress(Optional ByVal Port As eComPorts = COM1, Optional ByVal BaudRate As eBaudRates = BaudRate14400, _
                                                                        Optional ByVal StopBits As eStopBits = StopBit0, Optional ByVal Parity As eParity = [No Parity], _
                                                                        Optional ByVal FlowControl As eFlowControl = [No flow control]) As DirectPlayAddress
Attribute CreateCOMPortAddress.VB_HelpID = 2330
Attribute CreateCOMPortAddress.VB_Description = "Creates a DirectPlay address for the COM port."
'##BD Creates a DirectPlay address for the COM port.

'##PD Port Com port
'##PD BaudRate Baud rate.
'##PD StopBits Stop bits.
'##PD Parity Parity.
'##PD FlowControl Flow control.
    On Error GoTo Handler
    
    If mvarDPLobbyObject Is Nothing Then Exit Function 'Check to make sure we have a object.
    
    Set CreateCOMPortAddress = mvarDPLobbyObject.CreateCOMPortAddress(Port, BaudRate, StopBits, Parity, FlowControl)
    Exit Function
    
Handler:
    If Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "Lobby Class  CreateCOMPortAddress Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  CreateCOMPortAddress Function")
    End If
End Function

'##BLOCK_IS_NEW
Public Function CreateInternetAddress(ByVal Address As String, Optional ByVal Port As Long = 0) As DirectPlayAddress
Attribute CreateInternetAddress.VB_HelpID = 2331
Attribute CreateInternetAddress.VB_Description = "Creates a DirectPlay address for an Internet address."
'##BD Creates a DirectPlay address for an Internet address.
    
'##PD Address IP address. <i>Example: "192.168.0.1" or "microsoft.com". </i>
'##PD Port Port to use for communication. <i>Can be 0 to specify the default port.</i>
    On Error GoTo Handler
    
    If mvarDPLobbyObject Is Nothing Then Exit Function 'Check to make sure we have a object.
    
    Set CreateInternetAddress = mvarDPLobbyObject.CreateINetAddress(Address, Port)
    Exit Function
    
Handler:
    If Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "Lobby Class  CreateInternetAddress Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  CreateInternetAddress Function")
    End If
End Function

'##BLOCK_IS_NEW
Public Function CreateModemAddress(Modem As Modem, ByVal PhoneNumber As String) As DirectPlayAddress
Attribute CreateModemAddress.VB_HelpID = 2332
Attribute CreateModemAddress.VB_Description = "Creates a DirectPlay address for a modem."
'##BD Creates a DirectPlay address for a modem.

'##PD Modem Modem object to use.
'##PD PhoneNumber Phone number to dial.
    On Error GoTo Handler
    
    If mvarDPLobbyObject Is Nothing Then Exit Function 'Check to make sure we have a object.
    
    Set CreateModemAddress = mvarDPLobbyObject.CreateModemAddress(Modem.Name_, PhoneNumber)
    Exit Function
    
Handler:
    If Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "Lobby Class  CreateModemAddress Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  CreateModemAddress Function")
    End If
End Function

'##BLOCK_IS_NEW
Public Function CreateServiceProviderAddress(ServiceProvider As ServiceProvider) As DirectPlayAddress
Attribute CreateServiceProviderAddress.VB_HelpID = 2333
Attribute CreateServiceProviderAddress.VB_Description = "Creates a DirectPlay address for a service provider."
'##BD Creates a DirectPlay address for a service provider.
    
'##PD ServiceProvider Service provider object to use.
    On Error GoTo Handler
    
    If mvarDPLobbyObject Is Nothing Then Exit Function 'Check to make sure we have a object.
    
    Set CreateServiceProviderAddress = mvarDPLobbyObject.CreateServiceProviderAddress(ServiceProvider.Guid)
    Exit Function
    
Handler:
    If Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "Lobby Class  CreateServiceProviderAddress Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  CreateServiceProviderAddress Function")
    End If
End Function
'##BLOCK_IS_NEW
Public Function CreateIPXAddress() As DirectPlayAddress
Attribute CreateIPXAddress.VB_HelpID = 2334
Attribute CreateIPXAddress.VB_Description = "Creates a DirectPlay address for the IPX service provider."
'##BD Creates a DirectPlay address for the IPX service provider.
    
    On Error GoTo Handler
    
    If mvarDPLobbyObject Is Nothing Then Exit Function 'Check to make sure we have a object.
    
    Set CreateIPXAddress = mvarDPLobbyObject.CreateIPXAddress
    Exit Function
    
Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  CreateIPXAddress Function")
End Function
'##BLOCK_IS_NEW
Public Sub RefreshModems()
Attribute RefreshModems.VB_HelpID = 2335
Attribute RefreshModems.VB_Description = "Loads or reloads all of the available modems on the system."
'##BD Loads or reloads all of the available modems on the system.
    Dim i As Long, Modem As Modem
    
    If mvarDPLobbyObject Is Nothing Then Exit Sub     'Make sure we have an object.
    
    'Loop through and grab all the modems on the machine then place them into our collection.
    i = 1
    Do Until i > mvarDPLobbyObject.GetModemCount
        Set Modem = Modems.Add(CStr(i), mvarDPLobbyObject.GetModemName(i), mvarDPLobbyObject.GetModemName(i))
        i = i + 1
    Loop
End Sub


Public Sub RefreshRegisteredApplications()
Attribute RefreshRegisteredApplications.VB_HelpID = 2336
Attribute RefreshRegisteredApplications.VB_Description = "Reloads the RegisteredApplications collection with all of the applications on the system that have been registered with DirectPlay as lobby aware applications."
'##BD Reloads the RegisteredApplications collection with all of the applications on the system that have been registered with DirectPlay _
            as lobby aware applications.
    Dim RApp As RegisteredApp
    Dim DPRAEnum As DirectPlayEnumLocalApplications
    Dim lCount As Long
    On Error Resume Next
    
    Call RegisteredApplications.Clear 'delete all exisiting ones out of the collection.
    
    Set DPRAEnum = DPLobbyObject.GetDPEnumLocalApplications 'Grab the enum object
    lCount = 1
    
    'Cycle through the collection we got back and for each one add it too our collection.
    Do Until lCount > DPRAEnum.GetCount
        Set RApp = RegisteredApplications.Add(DPRAEnum.GetGuid(lCount), DPRAEnum.GetGuid(lCount))
        Call RApp.SetInformation(DPRAEnum.GetGuid(lCount), DPRAEnum.GetName(lCount))
        lCount = lCount + 1
    Loop

    Set DPRAEnum = Nothing
    Set RApp = Nothing
End Sub

Public Property Get RegisteredApplications() As RegisteredApps
Attribute RegisteredApplications.VB_HelpID = 2181
Attribute RegisteredApplications.VB_Description = "Returns a collection of Registered DirectPlay applications."
'##BD Returns a collection of Registered DirectPlay applications.
    Set RegisteredApplications = mvarRegisteredApplications
End Property




Public Property Get DPLobbyObject() As DirectPlayLobby3
Attribute DPLobbyObject.VB_HelpID = 2182
Attribute DPLobbyObject.VB_Description = "Returns the DirectPlayLobby3 object for custom operations."
'##BD Returns the DirectPlayLobby3 object for custom operations.
    Set DPLobbyObject = mvarDPLobbyObject
End Property

Public Sub Register(ByVal LauncherName As String, ByVal AppName As String, ByVal CmdLine As String, ByVal CurDir As String, _
                                    ByVal filename As String, ByVal Path As String, Optional ByVal bCustomGuid As Boolean = False, _
                                    Optional ByVal Guid As String, Optional ByVal Desc As String = "None")
Attribute Register.VB_HelpID = 2378
Attribute Register.VB_Description = "Registers a lobby-aware application with DirectPlay. An application must be registered so that a DirectPlay lobby can launch it."
'##BD Registers a lobby-aware application with DirectPlay. An application must be registered so that a DirectPlay lobby can launch it.

'##PD LauncherName Name of a launcher executable. The launcher is started by the lobby, and it in turn is responsible for launching _
                                        the application described in AppName. The launcher must reside in the same directory as the application.
'##PD AppName Name of the application. This title should not be localized. Use the strDescription member to localize the application name.
'##PD CmdLine Command line arguments to be passed to the executable when launched by a lobby.
'##PD CurDir Path that the current directory should be set to.
'##PD FileName Name of the executable to be launched. <i><b>Note: </b>The use of a stub executable should be avoided when launching from a _
                                lobby. In a lobby launch scenario, the stub should be bypassed and the main executable should be launched.</i>
'##PD Path Path where the executable is located.
'##PD bCustomGuid If this value is false a new Guid will be generated for you automatically. If True you must provide a value for the _
                                        Guid parameter.
'##PD Guid Globally unique identifier (GUID) of the application.
'##PD Desc Localized description of the application.
    Dim AppInfo As DPAPPLICATIONDESC2
    On Error GoTo Handler

    'Create a type object with the descriptions in it.
    With AppInfo 'Set parameters for the type from passed in information.
        .lFlags = 0
        .strAppLauncherName = LauncherName
        .strApplicationName = AppName
        .strCommandLine = CmdLine
        .strCurrentDirectory = CurDir
        .strDescription = Desc
        .strFilename = filename
        If bCustomGuid = True Then
            'Make sure the user provided a guid value
            If (Guid = "") Or (Guid = " ") Then
                Call MEngine.FireErrorEvent(1000000017, "You must specify a Guid value.", "Lobby Class   Register Method")
            Else
                .strGuid = Guid 'Use the one passed in by the user.
            End If
        Else
            .strGuid = DirectX.CreateNewGuid 'Create new guid.
        End If
        .strPath = Path
    End With
    
    Call DPLobbyObject.RegisterApplication(AppInfo) 'Register the application.
    Call MEngine.FireEvent(11)
    Exit Sub

Handler:
    If Err = DPERR_INVALIDFLAGS Then
        Call MEngine.FireErrorEvent(Err.Number, "The flags passed to this method are invalid.", "Lobby Class  Register Method")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "Lobby Class  Register Method")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  Register Method")
    End If
End Sub

Public Sub UnRegister(ByVal Guid As String)
Attribute UnRegister.VB_HelpID = 2184
Attribute UnRegister.VB_Description = "UnRegisters a lobby-aware application with DirectPlay."
'##BD UnRegisters a lobby-aware application with DirectPlay.

'##PD Guid Globally unique identifier (GUID) of the application to unregister.
    On Error GoTo Handler

    Call DPLobbyObject.UnregisterApplication(Guid)
    Call MEngine.FireEvent(12)
    Exit Sub

Handler:
    If Err = DPERR_INVALIDFLAGS Then
        Call MEngine.FireErrorEvent(Err.Number, "The flags passed to this method are invalid.", "Lobby Class  Register Method")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "Lobby Class  Register Method")
    ElseIf Err = DPERR_UNKNOWNAPPLICATION Then
        Call MEngine.FireErrorEvent(Err.Number, "An unknown application was specified.", "Lobby Class  Register Method")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Lobby Class  Register Method")
    End If
End Sub

Private Sub Class_Initialize()
    Set mvarRegisteredApplications = New RegisteredApps
    Set mvarModems = New Modems
    Set mvarDPLobbyObject = DirectX.DirectPlayLobbyCreate

    Call RefreshRegisteredApplications
    Call RefreshModems
End Sub

Private Sub Class_Terminate()
    Set mvarDPLobbyObject = Nothing
    Set mvarRegisteredApplications = Nothing
    Set mvarModems = Nothing
End Sub


