VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MultiEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Lobby"
Attribute VB_Ext_KEY = "Member1" ,"ServiceProviders"
Attribute VB_Ext_KEY = "Member2" ,"FTP"
'##CD MultiEngine class is the top level object. All other objects are children of this object.
Attribute VB_HelpID=2002
Attribute VB_Description="MultiEngine class is the top level object. All other objects are children of this object."
Option Explicit

'============================================================================================
'Events
Event OnError(ByVal ErrNumber As Long, ByVal ErrDescription As String, ByVal ErrLocation As String)
Attribute OnError.VB_HelpID = 2003
Attribute OnError.VB_Description = "This event is fired when an error occurs within the TrueVision7 3D Multi Engine."
'##ED This event is fired when an error occurs within the TrueVision7 3D Multi Engine.
'##PD ErrNumber Number of the error.
'##PD ErrDescription Description of the error.
'##PD ErrLocation Exact object and procedure the error occured.

Event ServiceProvidersLoaded(ServiceProviders As ServiceProviders)
Attribute ServiceProvidersLoaded.VB_HelpID = 2004
Attribute ServiceProvidersLoaded.VB_Description = "This event is fired after all the ServiceProviders have been loaded."
'##ED This event is fired after all the ServiceProviders have been loaded.
'##PD ServiceProviders Collection of ServiceProviders found on the current machine.

Event ServiceProviderInitialized(ServiceProvider As ServiceProvider)
Attribute ServiceProviderInitialized.VB_HelpID = 2005
Attribute ServiceProviderInitialized.VB_Description = "This event is fired after a specific ServiceProvider has been initialized for use."
'##ED This event is fired after a specific ServiceProvider has been initialized for use.
'##PD ServiceProvider ServiceProvider object that has been initialized.

Event SessionsLoaded(Sessions As Sessions, ServiceProvider As ServiceProvider)
Attribute SessionsLoaded.VB_HelpID = 2006
Attribute SessionsLoaded.VB_Description = "This event is fired after all the Sessions for the active ServiceProvider have been loaded."
'##ED This event is fired after all the Sessions for the active ServiceProvider have been loaded.
'##PD Sessions Collection of Sessions found using the initialized ServiceProvider.
'##PD ServiceProvider Active (Initialized) ServiceProvider.

Event PlayerAdded(SESSION As SESSION, Player As Player)
Attribute PlayerAdded.VB_HelpID = 2007
Attribute PlayerAdded.VB_Description = "This event is fired after a player for a session is added to the session. When refreshing the sessions players, each time MultiEngine detects a player this event is fired."
'##ED This event is fired after a player for a session is added to the session. When refreshing the sessions players, each time _
            MultiEngine detects a player this event is fired.
'##PD Session Session the player has been added too.
'##PD Player Player object representing the added player.

Event SessionJoined(SESSION As SESSION)
Attribute SessionJoined.VB_HelpID = 2008
Attribute SessionJoined.VB_Description = "This event is fired after a Session is joined."
'##ED This event is fired after a Session is joined.
'##PD Session Session that was joined.

Event Recieve(DPMsg As DirectPlayMessage, ByVal FromPlayer As Long)
Attribute Recieve.VB_HelpID = 2009
Attribute Recieve.VB_Description = "This event is fired when a message is recieved for the current player."
Attribute Recieve.VB_MemberFlags = "200"
'##ED This event is fired when a message is recieved for the current player.
'##PD DPMsg DirectPlay Message object that contains the message sent to the user.
'##PD FromPlayer Player's ID that sent the message. If this number matches the DPID_SYSMSG constant then the message is sent _
            by the DirectPlay system, if not the message is an application defined message.

Event Send(DPMsg As DirectPlayMessage)
Attribute Send.VB_HelpID = 2010
Attribute Send.VB_Description = "This event is fired after a message is sent."
'##ED This event is fired after a message is sent.
'##PD DPMsg DirectPlay Message object that contains the message sent.

Event MyPlayerCreated(Player As Player)
Attribute MyPlayerCreated.VB_HelpID = 2011
Attribute MyPlayerCreated.VB_Description = "This event is fired after the current player is created to participate."
'##ED This event is fired after the current player is created to participate.
'##PD Player Player object representing the current player.

Event FTPConnected()
Attribute FTPConnected.VB_HelpID = 2323
Attribute FTPConnected.VB_Description = "This event is fired when the Multi-Engine is connected to a FTP server."
'##ED This event is fired when the Multi-Engine is connected to a FTP server.

Event FTPDisconnected()
Attribute FTPDisconnected.VB_HelpID = 2324
Attribute FTPDisconnected.VB_Description = "This event is fired when the Multi-Engine is disconnected from a FTP server."
'##ED This event is fired when the Multi-Engine is disconnected from a FTP server.

Event FTPDirectoryChanged(ByVal Directory As String)
Attribute FTPDirectoryChanged.VB_HelpID = 2325
Attribute FTPDirectoryChanged.VB_Description = "This event is fired when the viewed directory has changed on the FTP server."
'##ED This event is fired when the viewed directory has changed on the FTP server.

Event Register()
Attribute Register.VB_HelpID = 2381
Attribute Register.VB_Description = "Fires when an application has successfully been registered with DirectPlay as a lobby supported application."
'##ED Fires when an application has successfully been registered with DirectPlay as a lobby supported application.

Event UnRegistered()
Attribute UnRegistered.VB_HelpID = 2382
Attribute UnRegistered.VB_Description = "Fires when an application has successfully been unregistered with DirectPlay."
'##ED Fires when an application has successfully been unregistered with DirectPlay.

'============================================================================================
'local variable(s) to hold property value(s)
Private mvarDirectPlayObject As DirectPlay4
Private mvarServiceProviders As ServiceProviders
Private mvarActiveServiceProvider As ServiceProvider
Private mvarLobby As Lobby
Private mvarTrueVision As TrueVision
Private mvarFTP As FTP
'##BLOCK_IS_NEW
Public Property Get FTP() As FTP
Attribute FTP.VB_HelpID = 2326
Attribute FTP.VB_Description = "Returns the FTP class object."
'##BD Returns the FTP class object.
    Set FTP = mvarFTP
End Property



'##BLOCK_IS_NEW
Public Property Get StartedByLobby() As Boolean
Attribute StartedByLobby.VB_HelpID = 2327
    If mvarLobby Is Nothing Then Exit Property
    
    If mvarLobby.GetConnectionSettings Is Nothing Then
        StartedByLobby = False
    Else
        StartedByLobby = True
    End If
End Property


'##BLOCK_IS_NEW
Property Get TrueVision3DObject() As TrueVision
Attribute TrueVision3DObject.VB_HelpID = 2284
Attribute TrueVision3DObject.VB_Description = "Returns/sets the TrueVision 3D Engine object. Returns/Sest the TrueVision object so that you can use some functionnalities of the 3D Engine (PAK files...)Returns/Sest the TrueVision object so that you can use some functionnalities of the 3D Engine (PAK files...)"
'##BD Returns/sets the TrueVision 3D Engine object.
    Set TrueVision3DObject = mvarTrueVision
End Property

Property Set TrueVision3DObject(TV As TrueVision)
'##BD Returns/Sest the TrueVision object so that you can use some functionnalities of the 3D Engine (PAK files...)
'##PD TV TrueVision object in your app.
    Set mvarTrueVision = TV

    'Get the FileOp
    Set FileOp = TV.FileOperation
End Property
Public Property Get Lobby() As Lobby
Attribute Lobby.VB_HelpID = 2145
    Set Lobby = mvarLobby
End Property



Friend Sub FireErrorEvent(ErrNum As Long, ErrDesc As String, ErrLoc As String)
Attribute FireErrorEvent.VB_HelpID = 2014
    RaiseEvent OnError(ErrNum, ErrDesc, ErrLoc)
End Sub

Friend Sub FireEvent(ByVal lEvent As Long, Optional SProvider As ServiceProvider, Optional Sessions As Sessions, _
                                        Optional SESSION As SESSION, Optional Player As Player, Optional DPMsg As DirectPlayMessage, _
                                        Optional ByVal FromPlayer As Long, Optional ByVal Directory As String)
Attribute FireEvent.VB_HelpID = 2015
    Select Case lEvent
        Case 1 'ServiceProviderInitialized
            RaiseEvent ServiceProviderInitialized(SProvider)

        Case 2 'SessionsLoaded
            RaiseEvent SessionsLoaded(Sessions, SProvider)

        Case 3 'PlayerAdded
            RaiseEvent PlayerAdded(SESSION, Player)

        Case 4 'Recieve
            RaiseEvent Recieve(DPMsg, FromPlayer)

        Case 5 'SessionJoined
            RaiseEvent SessionJoined(SESSION)

        Case 6 'MyPlayerCreated
            RaiseEvent MyPlayerCreated(Player)

        Case 7 'Send
            RaiseEvent Send(DPMsg)
            
        Case 8 'FTPConnected
            RaiseEvent FTPConnected
        
        Case 9 'FTPDisconnected
            RaiseEvent FTPDisconnected
        
        Case 10 'FTPDirectoryChanged
            RaiseEvent FTPDirectoryChanged(Directory)
            
        Case 11 'Register
            RaiseEvent Register
        
        Case 12 'UnRegistered
            RaiseEvent UnRegistered
        
    End Select
End Sub

Public Property Get ServiceProviders() As ServiceProviders
Attribute ServiceProviders.VB_HelpID = 2016
Attribute ServiceProviders.VB_Description = "Returns the Collection of ServiceProvider objects located on the current machine. (TCP/IP, IPX, Modem, Serial, etc.)"
'##BD Returns the Collection of ServiceProvider objects located on the current machine. <i>(TCP/IP, IPX, Modem, Serial, etc.)</i>
    Set ServiceProviders = mvarServiceProviders
End Property

Public Property Get DirectPlayObject() As DirectPlay4
Attribute DirectPlayObject.VB_HelpID = 2017
Attribute DirectPlayObject.VB_Description = "Returns the DirectPlay4 object being used by the MultiEngine. Use this property to perform custom functionality not provided by any child member of this engine."
'##BD Returns the DirectPlay4 object being used by the MultiEngine. Use this property to perform custom functionality not provided by any child member of this engine.
    Set DirectPlayObject = mvarDirectPlayObject
End Property
Public Function Initialize() As Boolean
Attribute Initialize.VB_HelpID = 2019
Attribute Initialize.VB_Description = "This function creates and readies DirectPlay4 and the MultiEngine. Note: Initialize must be called first before using any of it's methods and properties."
'##BD This function creates and readies DirectPlay4 and the MultiEngine. <i><b>Note:</b> Initialize must be called first before using any of it's methods and properties.</i>

'##RD Indicates the success or failure of the Initialize function. Returns True if successful or False if not.
    Dim oEnumConnections As DirectPlayEnumConnections, lCount As Long, ServiceProvider As ServiceProvider
    On Error GoTo Handler

    'Create direct play object.
    Set mvarDirectPlayObject = DirectX.DirectPlayCreate("")

    'Enumerate the connections on the users machine. Then fill the collection.
    Set oEnumConnections = mvarDirectPlayObject.GetDPEnumConnections("", DPCONNECTION_DIRECTPLAY)
    Set mvarServiceProviders = New ServiceProviders:    Set mvarServiceProviders.Parent = Me
    For lCount = 1 To oEnumConnections.GetCount
        Set ServiceProvider = mvarServiceProviders.Add(oEnumConnections.GetGuid(lCount), oEnumConnections.GetName(lCount), _
                    oEnumConnections.GetGuid(lCount), oEnumConnections.GetAddress(lCount), oEnumConnections.GetFlags(lCount), _
                    oEnumConnections.GetGuid(lCount))
    Next
    Initialize = True
    RaiseEvent ServiceProvidersLoaded(mvarServiceProviders)

ExitIt:
    Set oEnumConnections = Nothing
    Set ServiceProvider = Nothing
    Exit Function

Handler:
    RaiseEvent OnError(Err.Number, Err.Description, "MultiEngine Initialize Function")
    Initialize = False
End Function

Private Sub Class_Initialize()
    Set DirectX = New DirectX7
    Set mvarLobby = New Lobby
    Set mvarFTP = New FTP
    Set MEngine = Me
    NotificationID = DirectX.CreateEvent(frmEvents)
End Sub

Private Sub Class_Terminate()
    Set mvarServiceProviders = Nothing
    Set mvarDirectPlayObject = Nothing
    Set mvarActiveServiceProvider = Nothing
    Set mvarLobby = Nothing
    Set mvarTrueVision = Nothing
    Set mvarFTP = Nothing
    
    'If we successfully created the event we delete it here.
    If NotificationID <> 0 Then DirectX.DestroyEvent (NotificationID)

    Set DirectX = Nothing
End Sub



Public Property Get ActiveServiceProvider() As ServiceProvider
Attribute ActiveServiceProvider.VB_HelpID = 2022
Attribute ActiveServiceProvider.VB_Description = "Returns or sets the ServiceProvider that is in use by the current machine. Note: Only one ServiceProvider can be used at one time by DirectPlay.  "
'##BD Returns or sets the ServiceProvider that is in use by the current machine. <i><b>Note:</b> Only one ServiceProvider can be used at one time by DirectPlay.</i>
    Set ActiveServiceProvider = mvarActiveServiceProvider
End Property

Public Property Set ActiveServiceProvider(ByVal vData As ServiceProvider)
    Set mvarActiveServiceProvider = vData
End Property
