VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Player"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
'##CD Player class represents a DirectPlay Player within a Session.
Attribute VB_HelpID=2114
Attribute VB_Description="Player class represents a DirectPlay Player within a Session."
Option Explicit

Public Key As String

'local variable(s) to hold property value(s)
Private mvarDPID As Long
Private mvarFlags As Long
Private mvarLongName As String
Private mvarShortName As String
Private mvarType_ As mePlayerType
Private mvarAccountID As String
Private mvarPlayerCaps As DPCAPS
Private mvarPlayerData As String
Private mvarPlayerCapsGuaranteed As DPCAPS
Private mvarTypeFlags As CONST_DPPLAYERFLAGS
Private mvarIsHost As Boolean
Private mvarMyPlayer As Boolean

Public Enum mePlayerType
'##EN Type of Player.
    eGroup = 0
    '##EM eGroup Group.
    ePlayer = 1
    '##EM ePlayer Player.
End Enum

Attribute Key.VB_VarHelpID = 2117
Friend Sub SetMyPlayerFlag()
Attribute SetMyPlayerFlag.VB_HelpID = 2118
    mvarMyPlayer = True
End Sub

Public Property Get Type_() As mePlayerType
Attribute Type_.VB_HelpID = 2119
Attribute Type_.VB_Description = "Returns if the Player is a Player or Group."
'##BD Returns if the Player is a Player or Group.
    Type_ = mvarType_
End Property

Public Property Get TypeFlags() As CONST_DPPLAYERFLAGS
Attribute TypeFlags.VB_HelpID = 2120
Attribute TypeFlags.VB_Description = "Returns if the Player is an local, server, or spectator."
'##BD Returns if the Player is an local, server, or spectator.
    On Error GoTo Handler

    mvarTypeFlags = MEngine.DirectPlayObject.GetPlayerFlags(DPID)
    TypeFlags = mvarTypeFlags
    Exit Property

Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Session RefreshPlayers Function")
End Property
Public Property Get ShortName() As String
Attribute ShortName.VB_HelpID = 2121
Attribute ShortName.VB_Description = "Returns the friendly name."
'##BD Returns the friendly name.
    ShortName = mvarShortName
End Property

Public Property Get LongName() As String
Attribute LongName.VB_HelpID = 2122
Attribute LongName.VB_UserMemId = 0
Attribute LongName.VB_MemberFlags = "200"
Attribute LongName.VB_Description = "Returns the formal name."
'##BD Returns the formal name.
    LongName = mvarLongName
End Property

Public Property Get Flags() As Long
Attribute Flags.VB_HelpID = 2123
Attribute Flags.VB_Description = "Returns miscellaneous information."
'##BD Returns miscellaneous information.
    Flags = mvarFlags
End Property

Public Property Get DPID() As Long
Attribute DPID.VB_HelpID = 2124
Attribute DPID.VB_Description = "Returns the numerical identifier."
'##BD Returns the numerical identifier.
    DPID = mvarDPID
End Property

Friend Sub SetInformation(ByVal DPID As Long, ByVal Flags As Long, ByVal LName As String, ByVal SName As String, ByVal lType As Long)
Attribute SetInformation.VB_HelpID = 2125
    On Error Resume Next

    mvarType_ = lType
    mvarShortName = SName
    mvarLongName = LName
    mvarFlags = Flags
    mvarDPID = DPID
    mvarAccountID = MEngine.DirectPlayObject.GetPlayerAccountId(DPID)
End Sub

Public Property Get Data() As String
Attribute Data.VB_HelpID = 2126
Attribute Data.VB_Description = "Returns the application-specific data block."
'##BD Returns the application-specific data block.
    mvarPlayerData = MEngine.DirectPlayObject.GetPlayerData(mvarDPID, DPGET_LOCAL)
    Data = mvarPlayerData
End Property

Public Property Get Capabilities() As DPCAPS
Attribute Capabilities.VB_HelpID = 2127
Attribute Capabilities.VB_Description = "Returns the capabilities."
'##BD Returns the capabilities.
    On Error GoTo Handler

    Call MEngine.DirectPlayObject.GetPlayerCaps(DPID, mvarPlayerCaps, DPGETCAPS_DEFAULT)
    Capabilities = mvarPlayerCaps
    Exit Property

Handler:
    If Err = DPERR_INVALIDOBJECT Then
        Call MEngine.FireErrorEvent(Err.Number, "The DirectPlay object is invalid.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPLAYER Then
        Call MEngine.FireErrorEvent(Err.Number, "The player ID is not recognized as a valid player ID for this game session.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "ServiceProvider RefreshSessions Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Session RefreshPlayers Function")
    End If
End Property

Public Property Get CapabilitiesGuaranteed() As DPCAPS
Attribute CapabilitiesGuaranteed.VB_HelpID = 2128
Attribute CapabilitiesGuaranteed.VB_Description = "Returns the guaranteed capabilities."
'##BD Returns the guaranteed capabilities.
    On Error GoTo Handler

    Call MEngine.DirectPlayObject.GetPlayerCaps(DPID, mvarPlayerCapsGuaranteed, DPGETCAPS_GUARANTEED)
    CapabilitiesGuaranteed = mvarPlayerCapsGuaranteed
    Exit Property

Handler:
    If Err = DPERR_INVALIDOBJECT Then
        Call MEngine.FireErrorEvent(Err.Number, "The DirectPlay object is invalid.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPLAYER Then
        Call MEngine.FireErrorEvent(Err.Number, "The player ID is not recognized as a valid player ID for this game session.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "ServiceProvider RefreshSessions Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Session RefreshPlayers Function")
    End If
End Property
Public Property Get AccountID() As String
Attribute AccountID.VB_HelpID = 2129
Attribute AccountID.VB_Description = "Returns the Player's account identifier."
'##BD Returns the Player's account identifier.
    AccountID = mvarAccountID
End Property

Public Property Get IsHost() As Boolean
Attribute IsHost.VB_HelpID = 2130
Attribute IsHost.VB_Description = "Returns if this Player is the host of the associated Session."
'##BD Returns if this Player is the host of the associated Session.
    IsHost = mvarIsHost
End Property

Public Property Get MyPlayer() As Boolean
Attribute MyPlayer.VB_HelpID = 2131
Attribute MyPlayer.VB_Description = "Returns if this Player is represented as the Current Player or the player used by the gamer."
'##BD Returns if this Player is represented as the Current Player or the player used by the gamer.
    MyPlayer = mvarMyPlayer
End Property

