VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Players"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Player"
Attribute VB_Ext_KEY = "Member0" ,"Player"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Players class is a collection of Player objects associated with a Session.
Attribute VB_HelpID=2099
Attribute VB_Description="Players class is a collection of Player objects associated with a Session."
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private mvarMyPlayer As Player
Friend Sub Clear()
Attribute Clear.VB_HelpID = 2102
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub


Friend Function Add(Key As String, Optional sKey As String) As Player
Attribute Add.VB_HelpID = 2103
    'create a new object
    Dim objNewMember As Player
    Set objNewMember = New Player

    'set the properties passed into the method
    objNewMember.Key = Key
    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Function DestroyPlayer(ByVal PlayerID As Long) As Boolean
Attribute DestroyPlayer.VB_HelpID = 2104
Attribute DestroyPlayer.VB_Description = "Removes a Player from the collection and the associated Session."
'##BD Removes a Player from the collection and the associated Session.
    On Error Resume Next

    Call MEngine.DirectPlayObject.DestroyPlayer(PlayerID) 'Remove from directplay.
    Call Remove(CStr(PlayerID)) 'Remove from collection.
End Function

Public Property Get Item(vntIndexKey As Variant) As Player
Attribute Item.VB_HelpID = 2105
Attribute Item.VB_MemberFlags = "200"
    Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2106
Attribute Count.VB_Description = "Returns the total number of Player objects located within this collection."
'##BD Returns the total number of Player objects located within this collection.
    Count = mCol.Count
End Property


Friend Sub KillMyPlayer()
Attribute KillMyPlayer.VB_HelpID = 2107
    Set mvarMyPlayer = Nothing
End Sub

Friend Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_HelpID = 2108
    Call mCol.Remove(vntIndexKey)
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2109
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Friend Sub SetMyPlayer(Player As Player)
Attribute SetMyPlayer.VB_HelpID = 2110
    Set mvarMyPlayer = Player
End Sub

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
    Set mvarMyPlayer = Nothing
End Sub


Public Property Get MyPlayer() As Player
Attribute MyPlayer.VB_HelpID = 2113
Attribute MyPlayer.VB_Description = "Returns the Player object that represents the current Player."
'##BD Returns the Player object that represents the current Player.
    Set MyPlayer = mvarMyPlayer
End Property

