VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ServiceProvider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"Sessions"
'##CD ServiceProvider class represents a method of connectivity used to transmit data to another service provider. <i>(TCP/IP, IPX, Modem, Serial, etc.)</i>
Attribute VB_HelpID=2083
Attribute VB_Description="ServiceProvider class represents a method of connectivity used to transmit data to another service provider. (TCP/IP, IPX, Modem, Serial, etc.)"
Option Explicit

Public Key As String

'local variable(s) to hold property value(s)
Private mvarName_ As String
Private mvarGuid As String
Private mvarAddress As DirectPlayAddress
Private mvarFlags As Long
Private mvarParent As ServiceProviders
Private mvarInitialized As Boolean
Private mvarSessions As Sessions
Attribute Key.VB_VarHelpID = 2086
Public Property Set Parent(ByVal vData As ServiceProviders)
Attribute Parent.VB_HelpID = 2087
Attribute Parent.VB_Description = "Returns or sets the object directly above this ServiceProvider.  "
    Set mvarParent = vData
End Property

Public Property Get Parent() As ServiceProviders
'##BD Returns or sets the object directly above this ServiceProvider.
    Set Parent = mvarParent
End Property

Public Property Get Flags() As Long
Attribute Flags.VB_HelpID = 2088
Attribute Flags.VB_Description = "Returns the Flags (Options) for the ServiceProvider."
'##BD Returns the Flags (Options) for the ServiceProvider.
    Flags = mvarFlags
End Property

Public Property Get Address() As DirectPlayAddress
Attribute Address.VB_HelpID = 2089
Attribute Address.VB_Description = "Returns the DirectPlayAddress object for the ServiceProvider."
'##BD Returns the DirectPlayAddress object for the ServiceProvider.
    Set Address = mvarAddress
End Property

Public Property Get Guid() As String
Attribute Guid.VB_HelpID = 2090
Attribute Guid.VB_Description = "Returns the Guid for the ServiceProvider."
'##BD Returns the Guid for the ServiceProvider.
    Guid = mvarGuid
End Property

Public Function Initialize() As Boolean
Attribute Initialize.VB_HelpID = 2091
Attribute Initialize.VB_Description = "Initializes the ServiceProvider for use."
'##BD Initializes the ServiceProvider for use.
    On Error GoTo Handler

    If mvarAddress Is Nothing Then Exit Function 'Make sure we have a valid address object

    Call MEngine.DirectPlayObject.InitializeConnection(mvarAddress) 'Initialize the connection
    mvarInitialized = True
    Initialize = True
    Set MEngine.ActiveServiceProvider = Me 'Set the active service provider on the top object.
    Call MEngine.FireEvent(1, Me) 'Fire the ServiceProviderInitialized event

    'Grab all the active sessions running on this service provider and fire the event when finished.
    Call RefreshSessions(0)
    Exit Function

Handler:
    If Err = DPERR_ALREADYINITIALIZED Then
        Call MEngine.FireErrorEvent(Err.Number, "This object is already initialized.", "ServiceProvider Initialize Function")
    ElseIf Err = DPERR_UNAVAILABLE Then
        Call MEngine.FireErrorEvent(Err.Number, "The requested function is not available at this time.", "ServiceProvider Initialize Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "ServiceProvider Initialize Function")
    End If
    Initialize = False
    mvarInitialized = False
End Function


Public Property Get Name_() As String
Attribute Name_.VB_HelpID = 2092
Attribute Name_.VB_UserMemId = 0
Attribute Name_.VB_MemberFlags = "200"
Attribute Name_.VB_Description = "Returns the name for the ServiceProvider."
'##BD Returns the name for the ServiceProvider.
    Name_ = mvarName_
End Property

Public Function RefreshSessions(ByVal TimeOut As Long, Optional SessionData As DirectPlaySessionData) As Boolean
Attribute RefreshSessions.VB_HelpID = 2093
Attribute RefreshSessions.VB_Description = "Updates the Sessions associated with this connection."
'##BD Updates the Sessions associated with this connection.

'##PD TimeOut Time limit for retrieving information from a session before escaping.
'##PD SessionData DirectPlaySessionData object used to describe the type of Sessions to search for.
    Dim DPEnumSessions As DirectPlayEnumSessions, Session As Session
    Dim lCount As Long
    On Error GoTo Handler

    Call mvarSessions.Clear

    'If the user didn't pass in a sessiondata object we create one.
    If SessionData Is Nothing Then Set SessionData = MEngine.DirectPlayObject.CreateSessionData
    'Enumerate the sessions.
    Set DPEnumSessions = MEngine.DirectPlayObject.GetDPEnumSessions(SessionData, TimeOut, DPENUMSESSIONS_ALL)

    'Load the collection with the returned sessions.
    For lCount = 1 To DPEnumSessions.GetCount
        Set Session = mvarSessions.Add(DPEnumSessions.GetItem(lCount).GetGuidInstance, DPEnumSessions.GetItem(lCount), DPEnumSessions.GetItem(lCount).GetGuidInstance)
        Call Session.RefreshPlayers
    Next lCount
    RefreshSessions = True
    Call MEngine.FireEvent(2, Me, mvarSessions)
    Exit Function

Handler:
    If Err = DPERR_CONNECTING Then
        Call MEngine.FireErrorEvent(Err.Number, "The method is in the process of connecting to the network. The application should keep using the method until it returns DP_OK, indicating successful completion, or until it returns a different error.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_CONNECTIONLOST Then
        Call MEngine.FireErrorEvent(Err.Number, "The service provider connection was reset while data was being sent.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_EXCEPTION Then
        Call MEngine.FireErrorEvent(Err.Number, "An exception occurred when processing the request.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_GENERIC Then
        Call MEngine.FireErrorEvent(Err.Number, "An undefined error condition occurred.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDOBJECT Then
        Call MEngine.FireErrorEvent(Err.Number, "The DirectPlay object is invalid.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_NOCONNECTION Then
        Call MEngine.FireErrorEvent(Err.Number, "No communication link was established.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_UNINITIALIZED Then
        Call MEngine.FireErrorEvent(Err.Number, "The requested object has not been initialized.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_USERCANCEL Then
        Call MEngine.FireErrorEvent(Err.Number, "The user clicked Cancel in one of the DirectPlay service provider dialog boxes during a call to GetDPEnumSessions function.", "ServiceProvider RefreshSessions Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "ServiceProvider Initialize Function")
    End If
    RefreshSessions = False
End Function

Friend Sub SetInformation(Address As DirectPlayAddress, lFlags As Long, strGuid As String, SName As String)
Attribute SetInformation.VB_HelpID = 2094
    Set mvarAddress = Address
    mvarFlags = lFlags
    mvarGuid = strGuid
    mvarName_ = SName
End Sub

Private Sub Class_Initialize()
    Set mvarSessions = New Sessions
End Sub

Private Sub Class_Terminate()
    Set mvarAddress = Nothing
    Set mvarParent = Nothing
    Set mvarSessions = Nothing
End Sub



Public Property Get Initialized() As Boolean
Attribute Initialized.VB_HelpID = 2097
Attribute Initialized.VB_Description = "Returns if the ServiceProvider has been initialized."
'##BD Returns if the ServiceProvider has been initialized.
    Initialized = mvarInitialized
End Property

Public Property Get Sessions() As Sessions
Attribute Sessions.VB_HelpID = 2098
Attribute Sessions.VB_Description = "Returns the Sessions associated with this ServiceProvider."
'##BD Returns the Sessions associated with this ServiceProvider.
    Set Sessions = mvarSessions
End Property
